/* \mainpage

s/qmail -- fast, secure, and reliable email transmission
========================================================

WHAT IT IS:
----------
- s/qmail is a fork of qmail (1.03) including the 
  features of the Spamcontrol patch together with
  IPv6 capabilities and is 64 bit clean
- s/qmail is API- and plug-in-compatible with qmail,
  thus add-ons like vpopmail, ezmlm, and vmailmgr
  and many others work without changes 
- TLS 1.3 enabled using ucspi-ssl; 
  TLSA/DANE + cert pinning
- Wide scale QMTPS support
- Multi-tenancy capabilities
- s/qmail uses the concept of D.J. Bernstein's
  coding without compromise 
- Linux systemd compatible


INCULDING:
--------
The following (DJB) packages are included:

- checkpassword (as qmail-authuser)
- fastforward
- qmailanalog 
- qmail-mrtg


REQUIREMENTS:
------------
- fehQlibs (-17) -- can't build w/o it
- ucspi-ssl (> 0.12.x) -- won't run without it
- ucspi-tcp6 (generating the cdb)
- daemontools package (supervising the services),
  any other will do as well
- libidn2 for EAI support


INSTALLATION:
------------
- Read the INSTALL document


INTERNAL CHANGES FROM QMAIL:
---------------------------
- Group is now 'sqmail' instead of 'qmail'
- Exttodo + Bigtodo is default
- qmail(-queue) supports additional control tokens and return codes
- Old qmail code for sendmail compatibility removed 
- Added QMTPS capabilities
- IPv6 supported by default
- AMD64 enabled (64 + 32 bit clean), works on ARM/ARM64
- TLSA + SPF DNS lookup 
- SRS: srsforward & srsreverse
- SMTPUTF8 + IDN2 support for qmail-remote
- fehQlibs DNS stub resolver
- qmail-postgrey client
- Automatic DANE lookup for qmail-remote


USER INTERFACE CHANGES:
----------------------
- Port separator is ';' instead of ':' (due to IPv6)
- smtproutes supports authentication and localip setting
- Added SPF capabilities for qmail-smtpd + spfquery for testing
- Added DNS test routines: dnsfq, dnscname, dnstxt, dnstlsa
- Added fastforward package
- Added qmailanalog and qmail-mrtg
- Additional TLS control files for X.509 certificates, 
  key files and verification handling
- RECIPIENTS extension from Spamcontol
- Added PAMs for Recipient verification
  (qmail-vmailuser, qmail-smtpam)
- Added qmail-authuser PAM for SMTP and POP3 authentication; 
  supporting Dovecot natively
- Added qmail-qmaint for queue maintenance
- Added 'implicit TLS' support for qmail-remote and qmail-smtpam
  Port numbers may now prepended with 's' -> implicit TLS 

 
s/qmail (4.1) -- this README is not comprehensive yet 

See doc/CHANGELOG for version information.

Date: August, 31st 2021 (feh)
